use p4change2;
select * from (
  select
     year(headTime) as TheYear, month(headTime) As TheMonth, 
     weekofyear(headtime) As TheWeek, day(headtime) As TheDay,
     changelists.userName,
     fullPath,
     substring_index(substring_index(fullPath, '/', 3), '/', -1) as depot,
     substring_index(substring_index(fullPath, '/', 4), '/', -1) as project,
     COUNT(*) as Checkins
  from filerevs, changelists, files, users
  where filerevs.headChange = changelists.changelist
    AND filerevs.fileID = files.fileID
    AND changelists.userName = users.userName
  GROUP BY TheYear, TheMonth, TheWeek, TheDay, changelists.userName, project 
  ORDER BY TheYear, TheMonth, TheWeek, TheDay, changelists.userName, project )
as A where Checkins < 2000 