#!/usr/local/rbin/perl


# You can call this with a for loop in the Windows CMD shell!
# To process every changelist from 225861 to 231549 type this command:
#
#   for /l %a in (225861, 1, 231549) do perl procP4Changelist.pl %a
#
#


use DBI;
use IPC::System::Simple qw(capture system $EXITVAL); 
 
# database information
$db="p4change2";
$host="localhost";
$userid="root";
$passwd="password";
$port="3306";
$connectionInfo="dbi:mysql:$db;$host";

$changelistNum = shift;

# make connection to database
$dbh = DBI->connect($connectionInfo, $userid, $passwd)
  or die "Can't connect to the DB: $DBI::errstr\n";

# grab perforce changelist

$p4authfile = $ENV{'$P4HOME'} . "/scripts/P4AUTH.txt";

#print "Checking $p4authfile...";
if (-e $p4authfile)
{
	capture("p4 login < $p4authfile");
	#print ("Exists! Logging in.\n");
}
else
{
	#print ("does not exist. Hope there's a Perforce ticket!\n");
}

$changelist = '';
eval 
{
	@changelist = capture("p4 change -o $changelistNum"); 
	#print @changelist;
} or do 
{
	if (@changelist == "Change $changelistNum unknown.")
	{
		die "Unknown changelist  -";
	}
	else
	{
		die $@;
	}
};


$state = 0;
foreach $line (@changelist)
{
	if ($state==0)
	{
		if (($headDate) = ($line =~ /^Date:\s(.+)/))
		{
			$state++;
		}
	}
	elsif ($state==1)
	{
		if (($headUser) = ($line =~ /^User:\s(.+)/))
		{
			$state++;
		}
	}
	elsif ($state==2)
	{
		if ($line =~ /^Description:/)
		{
			$state++;
		}
	}
	elsif ($state==3)
	{
		($stripTab) = ($line =~ /^\s(.+)/);
		$headDesc = $headDesc . $stripTab . "\n";
	}
}

$headDate =~ s/'/''/g;
$headUser =~ s/'/''/g;
$headDesc =~ s/'/''/g;

#print "$headDate\n";
#print "$headUser\n";
#print "$headDesc\n";


$query = "select count(*) from changelists where changelist = $changelistNum";
$sth = $dbh->prepare($query);
$sth->execute();
my ( $count ) = $sth->fetchrow_array();

if ($count > 0)
{
	print "Error: Duplicate changelist $changelistNum\n";
	die;
}

$query = "INSERT INTO changelists VALUES($changelistNum, '$headDate', '$headUser', '$headDesc');";
$sth = $dbh->prepare($query);
$sth->execute();



$count = 0;


my @fstat = capture("p4 fstat -e $changelistNum -Ol //..."); 

$state = 0;
$sizeChange = 0;

foreach $line (@fstat)
{
	if (length($line)<=1)
	{
		# find the fileID for the file
		
		# first use a regex to split the depot file spec into a directory, filename, and extension
		($dir, $filename, $ext) = ($fileRev{depotFile} =~ /(.*)\/(.*)\.(.*)$/);
		
	
		$query = "SELECT files.fileID FROM files WHERE files.fullPath = '$fileRev{depotFile}';";
		$sth = $dbh->prepare($query);
		$sth->execute();		

		if ( ! ( $fileID = $sth->fetchrow_array() ) )
		{
			# we must add a new file to the files table
		    $query = "INSERT INTO files VALUES (null, '$fileRev{depotFile}', '$dir', '$filename', '$ext');";	
            #print "$query\n\n";
			$sth = $dbh->prepare($query);
			$sth->execute();
			$fileID = $sth->{'mysql_insertid'};					            
		}
		
		# if this isn't the first revision of the file, find the old Size and calculate the change in file size
		if ($fileRev{headRev} > 1)
		{
			$oldRev = $fileRev{headRev} - 1;
            $query = "SELECT filerevs.fileSize FROM filerevs WHERE filerevs.fileID = $fileID AND filerevs.headRev = $oldRev LIMIT 1";
            #print "$query\n\n";
			$sth = $dbh->prepare($query);
			$sth->execute();

			if ( $oldSize = $sth->fetchrow_array() )
			{
				$sizeChange = abs($fileRev{fileSize} - $oldSize);
			}
			else
			{
				$sizeChange = 0;
			}
		}

		if (($fileRev{headAction} eq "delete") || ($fileRev{headAction} eq "purge") )
		{
			$fileSize = 0;
		}
		else
		{
			$fileSize = $fileRev{fileSize}
		}
		
		$query = "INSERT INTO filerevs VALUES($fileID, $changelistNum, '$fileRev{headAction}', '$fileRev{headType}', $fileRev{headRev}, DATE_ADD('1970-01-01', INTERVAL $fileRev{headModTime} SECOND), $fileSize, $sizeChange)";
        #print "$query\n\n";  
		$sth = $dbh->prepare($query) or die "Bad SQL statement.";
		$sth->execute();
		
		$depotFile = '';
		$dir = '';
		$filename = '';
		$ext = '';
		$oldSize = 0;
		$oldHeadRev = 0;
		$sizeChange = 0;
		  
		undef $fileRev;
	}
	else
	{
		# still gathering keywords
		
		($keyword, $value) = ($line =~ /^\.\.\. (\w+) (.+)/);
		$value =~ s/'/''/g;
		
		#print "$keyword = $value\n";	
		$fileRev{$keyword} = $value;
		
		if ($keyword eq "desc")
		{
			undef @fstat;
		}
	}
}

print "Processed $changelistNum\n";
